function getParameterByName(name)
{
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(window.location.search);
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}

Ext.define('DSS.addon.selectTrigger', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    ckbScene:null,
    ckbAkm:null,
    lstConsumptions:null,
    checkboxArray:null,
    constructor : function(config) {
    	this.checkboxArray=[];
    	this.ckbScene=Ext.create('Ext.form.field.Checkbox', {
    		padding: '5 0 0 10',
    		boxLabel : _('observe button clicks'),
            allowBlank : false,
            style:{
	    		color: '#005138',
	        	'font-family': 'tahoma,arial,verdana,sans-serif'
	    	}
    	});
    	this.ckbAkm=Ext.create('Ext.form.field.Checkbox', {
    		padding: '5 0 0 10',
    		boxLabel : _('Observe motion detector events'),
            allowBlank : false,
            style:{
	    		color: '#005138',
	        	'font-family': 'tahoma,arial,verdana,sans-serif'
	    	}
    	});

        this.lstConsumptions=Ext.create('Ext.form.FieldSet',{     	   
     	   margin: '0 0 0 20',
     	   width:700,
     	   title:_('choose observated consumption events'),
     	   autoScroll:true,
     	   height:220
        });
    	for (var iIndex=0;iIndex<dss.staticDataModel.getSensorDeviceArray().length;iIndex++) {
    		var oDevice=dss.staticDataModel.getSensorDeviceArray()[iIndex];
    		for (var jIndex=0;jIndex<oDevice.sensorEvents.length;jIndex++) {
    			var dsid=oDevice.dSID;
    			var devName=oDevice.name;
    			var evtID=oDevice.sensorEvents[jIndex].id;
    			var evtName=oDevice.sensorEvents[jIndex].name;
        		var oCheckbox=Ext.create('Ext.form.field.Checkbox',{
        			id:dsid+"_"+evtID,
        			boxLabel:devName+": "+evtName,
        			style:{
        	    		color: '#005138',
        	        	'font-family': 'tahoma,arial,verdana,sans-serif'
        	    	}
        		});
        		this.checkboxArray.push(oCheckbox);
        		this.lstConsumptions.add(oCheckbox);
    		}
    	}
    	
        Ext.apply(this, {
            layout : {
                type : 'vbox'
            },           
            items : [ this.ckbScene, this.ckbAkm, this.lstConsumptions]
        });
        this.callParent(arguments);        	
    },
    reset : function() {
        this.setValue(null);
    },
    setValue : function(value) {
    	
		this.ckbAkm.setValue(false);
		this.ckbScene.setValue(false);
		for (var iIndex=0;iIndex<this.checkboxArray.length;iIndex++) {
			this.checkboxArray[iIndex].setValue(false);
		}

		if (value!=null) {
			this.ckbAkm.setValue(value.akm);
			this.ckbScene.setValue(value.scene);
			for (var iIndex=0;iIndex<value.deviceSensor.length;iIndex++) {
				for (var jIndex=0;jIndex<this.checkboxArray.length;jIndex++) {
					if (this.checkboxArray[jIndex].getId()==value.deviceSensor[iIndex]) {
						this.checkboxArray[jIndex].setValue(true);
					}
				}
			}
		}
    },
    isValid : function() {
    	for (var iIndex=0;iIndex<this.checkboxArray.length;iIndex++) {
    		if (this.checkboxArray[iIndex].getValue())
    			return true;
    	}    	
        return this.ckbAkm.getValue()||this.ckbScene.getValue();
    },
    getValue : function() {
    	var oArray=[];
    	for (var iIndex=0;iIndex<this.checkboxArray.length;iIndex++) {
    		if (this.checkboxArray[iIndex].getValue())
    			oArray.push(this.checkboxArray[iIndex].getId());
    	}
    	return {scene:this.ckbScene.getValue(),
    		    akm:this.ckbAkm.getValue(),
    		    deviceSensor:oArray};
    }
});


Ext.define('DSS.addon.event-checker', {

    extend : 'DSS.addon.Framework',

    config : {
        appName : 'event-checker',
        appId : 'event-checker',
        appVersion : '1.0.0.0',
        appIcon : 'default_icon.png'
    },

    getHelp : function() {
        return Ext.create('Ext.Component', {
            loader : {
                url : 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                autoLoad : true,
                disableCaching : false
            }
        });
    },

    getContent : function() {
        var me=this;
        
        var oConfig={
                defaultSortCol:'name',
                disabledProperty:'disabled',
                storeConfig: {
                    storeId : 'emailStore',
                    fields : [ {name:'disabled', sortType:'asBoolean'}, 
                               {name:'name', sortType:'asUCText'}, 
                               {name:'id'}, 
                               {name:'trigger', sortType:'asUCText'}, 
                               {name:'message', sortType:'asEmail'}, 
                               { name: 'conditions',  sortType: 'asCondition' },
                               { name: 'actions',  sortType: 'asAction'  },
                               { name: 'delay',    sortType: 'asTimespan' } ]
                },
                multiselect:true,
                columns: [{
                    header : _('Active'),
                    dataIndex : 'disabled',
                    resizable : false,
                    xtype: 'disabledcolumn', 
                    width : 50
                }, {
                    header : _('Name'),
                    dataIndex : 'name',
                    xtype: 'textcolumn',
                    width : 200
                }, {
                    header : _('observer'),
                    dataIndex : 'trigger',
                    flex : 1,
                    xtype: 'textcolumn',
                    customColumnRenderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
                    	var sString="<table>";
                    	if (val.scene)
                    		sString+="<tr><td>"+_('observe button clicks')+"</td><tr>";
                    	else
                    		sString+="";//<tr><td>"+_('observe no button clicks')+"</td><tr>";
                    	if (val.akm)
                    		sString+="<tr><td>"+_('observe motiondetector and presencedetector')+"</td><tr>";
                    	else
                    		sString+="";//<tr><td>"+_('react not on motiondetector and presencedetector')+"</td><tr>";
                    	
                    	for (var iIndex=0;iIndex<val.deviceSensor.length;iIndex++) {
                    		var sValue=(val.deviceSensor[iIndex]).split('_');
                    		var deviceObject=dss.staticDataModel.getDevice(sValue[0]);
                    		var eventID=sValue[1];
                    		sString+="<tr><td>"+
                    		Ext.String.format2(_('observe {message} from {device}'),{
                    			message:dss.staticDataModel.getNameForSensorEvent(deviceObject,eventID),
                    			device:deviceObject.name
                    		})+ "</td><tr>";
                    	}
                    	return sString + "</table>";
                    }
                }, {
                    header: _('Period'),
                    dataIndex: 'delay',
                    xtype: 'timespancolumn',
                    width: 80,
                    customColumnRenderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
                    	 var pad = function(i) { return (i < 10 ? '0'+i : i); };
                         var sec = val;
                         var min = Math.floor(sec / 60);
                         sec -= min * 60;
                         var hou = Math.floor(min / 60);
                         min -= hou * 60;
                         
                         var fActive=view.up().isFieldActive(record);
                         if (!fActive)
                         	return '<span style="color:grey;">'+pad(hou) +':'+ pad(min)+'</span>';
                         else
                         	return pad(hou) +':'+ pad(min);      
                    }
                }, {
                    header : _('Message'),
                    dataIndex : 'message',
                    xtype:'emailcolumn',
                    flex : 1,
                    customColumnRenderer: function(val, metadata, record, rowIdx, colIdx, store, view) {
                    	if (val=="") {
                    		return _('no message should be send');
                    	}
                    	return null;
                    }
                }, {
                    header : _('Activity'),
                    dataIndex: 'actions', 
                    xtype: 'actioncolumn',
                    maintainFlex : true,
                    flex : 1
                },{
                    header: _('Conditions'),
                    dataIndex: 'conditions', // alibi index
                    xtype: 'conditioncolumn',
                    maintainFlex: true,
                    flex: 1,
                    customRendererOptions:{hideEnabled:true,hideWeekdays:false,hideGenericSystemStates:false,hideZoneStates:false,hideTimeframe:false,filterSystemState:[],
                    	stateTitles:[{name:'daylight',value:true,title:_('grid_daylight_true')},{name:'daylight',value:false,title:_('grid_daylight_false')},
                    	             {name:'daynight',value:true,title:_('grid_daynight_true')},{name:'daynight',value:false,title:_('grid_daynight_false')},
                    	             {name:'panic',value:'1',title:_('grid_panic_active')},{name:'panic',value:'2',title:_('grid_panic_inactive')},
                    	             {name:'presence',value:'present',title:_('grid_presence_present')},{name:'presence',value:'absent',title:_('grid_presence_absent')},
                    	             {name:'fire',value:'1',title:_('grid_fire_active')},{name:'fire',value:'2',title:_('grid_fire_inactive')},
                    	             {name:'hail',value:'1',title:_('grid_hail_active')},{name:'hail',value:'2',title:_('grid_hail_inactive')},
                    	             {name:'wind',value:'1',title:_('grid_wind_active')},{name:'wind',value:'2',title:_('grid_wind_inactive')},
                    	             {name:'rain',value:'1',title:_('grid_rain_active')},{name:'rain',value:'2',title:_('grid_rain_inactive')},
                    	             {name:'frost',value:'1',title:_('grid_frost_active')},{name:'frost',value:'2',title:_('grid_frost_inactive')},
                    	             {name:'alarm',value:'1',title:_('grid_alarm_active')},{name:'alarm',value:'2',title:_('grid_alarm_inactive')},
                    	             {name:'alarm2',value:'1',title:_('grid_alarm2_active')},{name:'alarm2',value:'2',title:_('grid_alarm2_inactive')},
                    	             {name:'alarm3',value:'1',title:_('grid_alarm3_active')},{name:'alarm3',value:'2',title:_('grid_alarm3_inactive')},
                    	             {name:'alarm4',value:'1',title:_('grid_alarm4_active')},{name:'alarm4',value:'2',title:_('grid_alarm4_inactive')},
                    	             {name:'holiday', value:'on',title:_('grid_holiday_on')},{name:'holiday', value:'off',title:_('grid_holiday_off')}]}
                }],     
                buttonText: {
                    newButton: _('New observer'),
                    editButton: _('Edit observer'),
                    enableButton:_('Activate observer'),
                    disableButton:_('Deactivate observer'),
                    testButton: _('Test observer'),
                    deleteButton: _('Delete observer')
                },
                editorConfig:{
                    title : _('Observerproperties'),
                    staticControls : [{
                        type : 'text',
                        label : _('Name'),
                        id : 'name'
                    }, {
                        type: 'timespan',
                        label: _('Period'),
                        id: 'delay',
                        hideSecond:true
                    }, {
                        type : 'hidden',
                        label : _('id'),
                        id : 'id'
                    }],
                    tabControls :  [{
                        tabLabel : _('What to observe'),
                        tabDescription : _('Specify the eventtypes which are observed'),
                        content : [ {
                            type : 'custom',
                            id : 'trigger',
                            control:Ext.create('DSS.addon.selectTrigger',{}),
                            flex : true
                        }]
                    } , {
                        tabLabel : _('Message'),
                        tabDescription : _('Provide the Message, which will be send.'),
                        content : [ {
                            type : 'MessageControl',
                            id : 'message',
                            title : _('Message'),
                            flex : true
                        }]
                    } ,  {
                        tabLabel : _('Activity'),
                        tabDescription : _('Choose the activities, which should be executed.'),
                        content : [{
                            type : 'ActionConfigurator',
                            id : 'actions',
                            flex : true,
                            withDelay : true,
                            allowNoAction : true
                        }]
                    },{
                        tabLabel : _('Conditions'),
                        tabDescription : _('Choose the conditions.'),
                        content : [{
                            type : 'ConditionConfigurator',
                            id : 'conditions',
                            conditions:[
                                        {type:'singleItem',title:_('state_daynight'),entry:[
                                              {type:'state',name:'daylight',value:true,title:Ext.String.format2(_('daynight_bright'),{
		                                            	duskTime:dss.staticDataModel.getDusk(),
		                                            	dawnTime:dss.staticDataModel.getDawn()
		                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_true'),{
		                                            	duskTime:dss.staticDataModel.getDusk(),
		                                            	dawnTime:dss.staticDataModel.getDawn()
		                                            })},
                                              {type:'state',name:'daylight',value:false,title:Ext.String.format2(_('daynight_dark'),{
	                                            	duskTime:dss.staticDataModel.getDusk(),
	                                            	dawnTime:dss.staticDataModel.getDawn()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_false'),{
	                                            	duskTime:dss.staticDataModel.getDusk(),
	                                            	dawnTime:dss.staticDataModel.getDawn()
	                                            })},
                                              {type:'state',name:'daynight',value:true,title:Ext.String.format2(_('daynight_day'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_true'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            })},
                                              {type:'state',name:'daynight',value:false,title:Ext.String.format2(_('daynight_night'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_false'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            })},
	                                            
	                                            ]},
                                        {type:'timeframe',title:_('Timeframe')},
                                        {type:'weekdays',title:_('Weekdays')},
                                        {type:'deviceState',title:_('automatic devices')},
                                        {type:'singleItem',title:_('state_presence'),entry: [
                                               {type:'state',name:'presence',value:'present',title:_('presence_present'),gridText:_('grid_presence_present')},
                                               {type:'state',name:'presence',value:'absent',title:_('presence_absent'),gridText:_('grid_presence_absent')}]},                                               
                                        {type:'singleItem',title:_('state_holiday'),entry: [
                                               {type:'state',name:'holiday',value:'on',title:_('holiday_on'),gridText:_('grid_holiday_on')},
                                               {type:'state',name:'holiday',value:'off',title:_('holiday_off'),gridText:_('grid_holiday_off')}]},
	                                   {type:'multiItem',title:_('weather trigger'),entry: [
	                                            {type:'state',name:'rain',value:'1',title:_('rain active'),gridText:_('grid_rain_active'),group:1},
	                                            {type:'state',name:'rain',value:'2',title:_('rain inactive'),gridText:_('grid_rain_inactive'),group:1},
	                                            {type:'state',name:'wind',value:'1',title:_('wind active'),gridText:_('grid_wind_active'),group:2},
	                                            {type:'state',name:'wind',value:'2',title:_('wind inactive'),gridText:_('grid_wind_inactive'),group:2},
	                                            {type:'state',name:'hail',value:'1',title:_('hail active'),gridText:_('grid_hail_active'),group:3},
                                               {type:'state',name:'hail',value:'2',title:_('hail inactive'),gridText:_('grid_hail_inactive'),group:3},
                                               {type:'state',name:'frost',value:'1',title:_('frost active'),gridText:_('grid_frost_active'),group:4},
                                               {type:'state',name:'frost',value:'2',title:_('frost inactive'),gridText:_('grid_frost_inactive'),group:4},
                                               {type:'state',name:'sun',value:'1',title:_('sun active'),gridText:_('grid_sun_active'),group:5},
                                               {type:'state',name:'sun',value:'2',title:_('sun inactive'),gridText:_('grid_sun_inactive'),group:5}]},
                                               {type:'state',name:'service',value:'1',title:_('service active'),gridText:_('grid_service_active'),group:6},
                                               {type:'state',name:'service',value:'2',title:_('service inactive'),gridText:_('grid_service_inactive'),group:6},
	                                   {type:'multiItem',title:_('Security'),entry: [
	                                           {type:'state',name:'fire',value:'1',title:_('fire active'),gridText:_('grid_fire_active'),group:1},
	                                           {type:'state',name:'fire',value:'2',title:_('fire inactive'),gridText:_('grid_fire_inactive'),group:1},
	                                            {type:'state',name:'panic',value:'1',title:_('panic_active'),gridText:_('grid_panic_active'),group:2},
	                                            {type:'state',name:'panic',value:'2',title:_('panic_inactive'),gridText:_('grid_panic_inactive'),group:2},
	                                            {type:'state',name:'alarm',value:'1',title:_('alarm_active'),gridText:_('grid_alarm_active'),group:3},
	                                            {type:'state',name:'alarm',value:'2',title:_('alarm_inactive'),gridText:_('grid_alarm_inactive'),group:3},
	                                            {type:'state',name:'alarm2',value:'1',title:_('alarm2_active'),gridText:_('grid_alarm2_active'),group:4},
	                                            {type:'state',name:'alarm2',value:'2',title:_('alarm2_inactive'),gridText:_('grid_alarm2_inactive'),group:4},
	                                            {type:'state',name:'alarm3',value:'1',title:_('alarm3_active'),gridText:_('grid_alarm3_active'),group:5},
	                                            {type:'state',name:'alarm3',value:'2',title:_('alarm3_inactive'),gridText:_('grid_alarm3_inactive'),group:5},
	                                            {type:'state',name:'alarm4',value:'1',title:_('alarm4_active'),gridText:_('grid_alarm4_active'),group:6},
	                                            {type:'state',name:'alarm4',value:'2',title:_('alarm4_inactive'),gridText:_('grid_alarm4_inactive'),group:6}]},
                                        {type:'zonestate',title:_('ZoneState')},
                                        {type:'clusterstate',title:_('Cluster State')}
                            ],
                            flex : true
                        }]
                    }]
                },
                listeners: {
                    'loadDataStore':function (grid){
                        me.loadParameter(grid);
                    },
                    'saveEntry':function (grid,values){    
                        
                        me.waitAndReload(grid,{
                            actions : 'save',
                            value : Ext.JSON.encode(values)
                        });
                    },
                    'enableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        me.waitAndReload(grid, {
                            actions : 'enable',
                            id : Ext.JSON.encode(idVal)
                        });
                     },
                    'disableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}                      
                        me.waitAndReload(grid, {
                            actions : 'disable',
                            id : Ext.JSON.encode(idVal)
                        });
                    },
                    'deleteEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        me.waitAndReload(grid, {
                            actions : 'delete',
                            id : Ext.JSON.encode(idVal)
                        });
                    },
                    'testEntry':function (grid,entry){
                        dss.raiseEvent('event-checker', {
                            actions : 'test',
                            id : entry.get('id')
                        });
                    }
                }
        };             
        return Ext.create('DSS.gridPanel', oConfig);
    },
    loadParameter : function(grid) {
    	grid.editorWindow.editControls.message.isValid=function(){return true};
    	grid.setStatus(_('Loading ...'));
        var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/event-checker/thresholds/*(*)/*(*)/*(*)/*(*)'
        });
        var result = Ext.JSON.decode(sString);
        
        oResultObject=dss.parsePropertyQueryAnswer(result,[{name:'name',type:'simple'},
                                                           {name:'id',type:'simple'},
                                                           {name:'disabled',type:'condition/enabled'},
                                                           {name:'message', type:'message'},
                                                           {name: 'delay', type: 'simple'},
                                                           {name: 'actions', type: 'action'},
                                                           {name: 'conditions', type: 'condition'}]);    
        if (oResultObject!=null) {
            for (var iIndex=0;iIndex<oResultObject.length;iIndex++) {
                oResultObject[iIndex].grouping=unescape(oResultObject[iIndex].name).split(' ')[0];
                var oObject={};
                var oRes=result.result.thresholds[iIndex];

				for (var sMasterKey in oRes) 
					if (!isNaN(parseInt(sMasterKey,10))) {                
		                for (var kIndex=0;kIndex<oRes[sMasterKey].length;kIndex++) {
		                	if (oRes[sMasterKey][kIndex].trigger!=null)
		                    	{
		                    		oObject.scene=oRes[sMasterKey][kIndex].scene;
		                    		oObject.akm=oRes[sMasterKey][kIndex].akm;
		                    		oObject.deviceSensor=[];
		                    		if (oRes[sMasterKey][kIndex].trigger!=null) {
		                    			for (lIndex=0;lIndex<oRes[sMasterKey][kIndex].trigger.length;lIndex++) {
		                    				if (oRes[sMasterKey][kIndex].trigger[lIndex].akm==null)
		                        				if (oRes[sMasterKey][kIndex].trigger[lIndex].scene==null) {
		                        					var deviceEvents=oRes[sMasterKey][kIndex].trigger[lIndex];
		                        					for (var sKey in deviceEvents) {
		                        						if (!isNaN(parseInt(sKey,10))) {
		                        							oObject.deviceSensor.push(deviceEvents[sKey]);
		                        						}
		                        					}
		                        				}
		                    			}
		                    		}
		                    	}
		                }
					}
                oResultObject[iIndex].trigger=oObject;
            }
            grid.loadParameter(oResultObject);
        }
        grid.setStatus(_('Ready'));
    },
    waitAndReload : function(grid,parameter) {
    	grid.setStatus(_('Saving ...'));
        var me = this;
        
    	dss.pushAndQuery('event-checker-config',parameter,
		         'event-checker.saved',function(eventData) {
  		 me.loadParameter(grid);
			 return true;
		});              
    }
});

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/event-checker.po']);
    var EmailEdit = Ext.create('DSS.addon.event-checker');
    EmailEdit.initPage();
});
